<?php
    $isApiKeyValid = fusedesk_verifyscope();
    $isApiKeyInUrl = array_key_exists('apikey', $_GET);
    $isConfigured  = get_option('fusedesk_appname') && get_option('fusedesk_apikey');

    if($isConfigured
       && !$isApiKeyValid
    ) {
            ?><div id="message" class="error"><p>
            <?php _e('There was an error connecting to your FuseDesk App. Please check that your FuseDesk API Key is setup correctly and has the right permissions.', 'fusedesk'); ?>
            </p></div>
    <?php } ?>

<div class="wrap" xmlns="http://www.w3.org/1999/html">
    <div id="icon-tools" class="icon32"></div>
    <h2><?php _e('FuseDesk Options', 'fusedesk'); ?></h2>

    <form method="post" action="options.php">
        <?php wp_nonce_field('update-options'); ?>
        <?php settings_fields('fusedesk'); ?>

        <p><?php _e('Please enter your FuseDesk application name and your <a href="#apikey">FuseDesk API Key</a> below.', 'fusedesk'); ?></p>

        <?php
        if(!get_option('fusedesk_apikey')
           && $isApiKeyInUrl
        ) {
            echo('<div id="message" class="updated"><p>');
            _e('Your FuseDesk API Key has been auto-filled into the form below. Make sure to click the <b>Save Changes</b> button below.','fusedesk');
            echo('</p></div>');
        }
        ?>

        <table class="form-table">

            <tr valign="top">
                <th scope="row"><?php _e('App Name:', 'fusedesk'); ?></th>
                <td><code>https://<input type="text" name="fusedesk_appname" id="fusedesk_appname" value="<?php echo(fusedesk_guessappname()); ?>" />.FuseDesk.com</code>
                <?php if(!get_option('fusedesk_apikey')) { ?>
                    <input type="button" id="fusedesk_getkey" value="<?php _e('Get FuseDesk API Key'); ?>" class="button-secondary"></td>
                <?php } ?>
            </tr>

            <tr valign="top">
                <th scope="row"><a href="#apikey"><?php _e('FuseDesk API Key', 'fusedesk'); ?></a>:</th>
                <td><input type="text" name="fusedesk_apikey" id="fusedesk_apikey" value="<?php echo(
                    get_option('fusedesk_apikey') ? get_option('fusedesk_apikey') :
                        ($isApiKeyInUrl ? $_GET['apikey'] : '')
                    ); ?>" size="32" />
                    <input type="button" id="fusedesk_testbutton" value="<?php _e('Test','fusedesk');?>" class="button-secondary">
                </td>
            </tr>
        </table>

        <?php if($isApiKeyValid) { ?>

        <h2><?php _e('Departments', 'fusedesk'); ?></h2>

        <p><?php _e('Which department would you like to assign cases to by default?', 'fusedesk'); ?></p>

            <?php

            if($departments =  fusedesk_departments())
            {
                ?>
                <select name="fusedesk_defaultdepartment" id="fusedesk_defaultdepartment">
                <?php

                foreach($departments as $departmentId => $departmentName)
                {
                    echo('<option value="'.$departmentId.
                        '" '.selected(get_option('fusedesk_defaultdepartment'), $departmentId, false).
                        '> '.$departmentName.' ('.$departmentId.')').'</option>';
                }

                ?>
                </select>
                <button class="button-secondary" id="fusedesk_departments_refresh"><?php _e('Refresh', 'fusedesk'); ?></button>
                <p><?php _e('Want to assign cases to a different department on a new case form? Note down the ID of the department from the list above!', 'fusedesk'); ?></p>
                <?php
            } else {
	            _e('No departments found?', 'fusedesk');
            }
            ?>


        <h2><?php _e('Support Reps', 'fusedesk'); ?></h2>

        <p><?php _e('Which rep would you like to assign cases to by default?', 'fusedesk'); ?></p>

        <?php
            if($reps = fusedesk_reps())
            {
                echo('<select name="fusedesk_defaultrep" id="fusedesk_defaultrep">');
                echo('<option value="" '.selected(get_option('fusedesk_defaultrep'), '', false).'>');
                _e('Assign Randomly', 'fusedesk');
                echo('</option>');
                foreach($reps as $repUserId => $repName)
                {
	                echo('<option value="'.$repUserId.
	                     '" '.selected(get_option('fusedesk_defaultrep'), $repUserId, false).
	                     '> '.$repName.' ('.$repUserId.')'.
	                     '</option>');
                }
                ?>
                </select>
	            <button class="button-secondary" id="fusedesk_reps_refresh"><?php _e('Refresh', 'fusedesk'); ?></button>
                <p><?php _e('Want to assign cases to a different rep on a new case form? Note down the ID of the rep from the list above!', 'fusedesk'); ?></p>
                <?php
            } else {
                _e('No reps found?', 'fusedesk');
            }
        ?>

        <h2><?php _e('Live Chat Widget', 'fusedesk'); ?></h2>
            <?php
            if(($integrations = fusedesk_chatwidgets())
               && is_array($integrations)
            ) {
                ?>
                <p><?php _e('Which Live Chat Widget would you like to use on this site?', 'fusedesk'); ?></p>
                <select name="fusedesk_livechatid" id="fusedesk_defaultchatwidget">
                <?php
                echo('<option value="" '.selected(get_option('fusedesk_livechatid'), '', false).'>[');
                _e('Live Chat Disabled', 'fusedesk');
                echo(']</option>');

                foreach($integrations as $integrationId => $integrationName)
                {
                    echo('<option value="'.$integrationId.
                        '"'.selected(get_option('fusedesk_livechatid'), $integrationId, false).
                        '> '.$integrationName.'</option>');
                }
                ?>
                </select>
                <button class="button-secondary" id="fusedesk_chatwidgets_refresh"><?php _e('Refresh', 'fusedesk'); ?></button>

                <p><?php _e('If a website visitor is logged in, should we pre-fill their contact info in Live Chat? This will allow your support team to more easily see who they\'re helping right in FuseDesk', 'fusedesk'); ?></p>

                <select name="fusedesk_livechat_setcontact">
                    <option value="yes" <?php echo(selected(get_option('fusedesk_livechat_setcontact'), 'yes', false)); ?>><?php _e('Yes! (Recommended)', 'fusedesk');?></option>
                    <option value="no"  <?php echo(selected(get_option('fusedesk_livechat_setcontact'), 'no', false));  ?>><?php _e('No thank you', 'fusedesk');?></option>
                </select>

                <p>
                    <a href="https://<?php echo(get_option('fusedesk_appname')) ?>.fusedesk.com/app/#chatsettings" target="_blank"><?php _e('Configure Live Chat in FuseDesk...', 'fusedesk'); ?></a>
                </p>
                <?php
            } elseif (is_object($integrations)
                      && property_exists($integrations, 'errorcode')
                      && ($integrations->errorcode === 'api_error_noscope')
            ) {
            ?>
                <p><?php _e('Uh oh! This FuseDesk API Key does not have access to your live chat integrations. Edit this API Key in FuseDesk and check the box for the <b>View and Search Integrations</b>.'); ?></p>
                <p>
                    <a href="" class="button"><?php _e('Check Again', 'fusedesk'); ?></a>
                    <a href="https://<?php echo(get_option('fusedesk_appname')) ?>.fusedesk.com/app/#apikeys"
                       class="button-primary" target="_blank"><?php _e('Grant Permission to Integrations...', 'fusedesk'); ?></a>
                </p>
                <?php
            } elseif (is_object($integrations)
                      && property_exists($integrations, 'errorcode')
            ) {
                /* translators: error code, error message */
                printf(__('API Error (%1$s): %2$s', 'fusedesk'), $integrations->errorcode, $integrations->error);
            } else {
                ?>

                <p><?php _e('It looks like you don\'t have Live Chat setup yet! FuseDesk\'s Live Chat allows you to chat with your website visitors right from inside of FuseDesk!', 'fusedesk'); ?></p>
                <p>
                    <a href="" class="button"><?php _e('Check Again', 'fusedesk'); ?></a>
                    <a href="https://<?php echo(get_option('fusedesk_appname')) ?>.fusedesk.com/app/#chatsettings" class="button" target="_blank"><?php _e('Setup Live Chat...', 'fusedesk'); ?></a>
                </p>

                <?php
            }
            ?>

        <h2><?php _e('Powered by FuseDesk', 'fusedesk'); ?></h2>

        <p>
            <?php
            fusedesk_poweredby(true); // Sync up our account status on page load...
            $planName = get_option('fusedesk_planname');
            $hasFooter = filter_var(get_option('fusedesk_footerlink'), FILTER_VALIDATE_BOOLEAN);

            if($hasFooter)
            {
                /* translators: account type, i.e. Lite, Pro, Enterprise */
                printf(__('You currently have a FuseDesk %s account with the Powered by FuseDesk footer enabled in your app.', 'fusedesk'), $planName);
            } else {
	            /* translators: account type, i.e. Lite, Pro, Enterprise */
                printf(__('You currently have a FuseDesk %s account with the Powered by FuseDesk footer disabled in your app.', 'fusedesk'), $planName);
            }

            /* translators: URL */
            printf(__('You can adjust this in your <a href="%s" target="_blank">App Options</a>.', 'fusedesk'), 'https://'.get_option('fusedesk_appname').'.fusedesk.com/app/#options');
            ?>
        </p>

        <?php
    } ?>

        <input type="hidden" name="action" value="update" />

        <p class="submit">
            <input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
        </p>

    </form>

<?php if(!$isConfigured
 && !$isApiKeyInUrl) {
?>

    <div style="padding: 10px 20px 20px; border: 1px solid #dddddd; border-radius: 5px; max-width: 700px; background: rgba(255,255,255,.3);">
        <h2><?php _e('FuseDesk. The First and Only Helpdesk You\'ll Ever Need.', 'fusedesk'); ?></h2>

        <p><?php _e('Focus on your customers, not your software. Try FuseDesk absolutely free. No credit cards. No time limit. No obligations. You\'re going to love FuseDesk, the new way to helpdesk.', 'fusedesk'); ?></p>

        <p><?php
			/* translators: URL */
			printf(__('Get your totally free, fully functionally <a href="%s">FuseDesk App</a> today to organize your customer support and messaging!', 'fusedesk'), 'https://www.fusedesk.com/?utm_campaign=WordPress-Plugin&utm_source=WordPress-Plugin-Link'); ?>
        </p>


        <p>
            <span class="dashicons dashicons-yes-alt"></span>
	        <?php _e('Free Live Chat', 'fusedesk'); ?>
            &nbsp; &nbsp;
            <span class="dashicons dashicons-yes-alt"></span>
	        <?php _e('Easy Setup', 'fusedesk'); ?>
            &nbsp; &nbsp;
            <span class="dashicons dashicons-yes-alt"></span>
	        <?php
                $installedPartners = fuseDeskPartnersInstalled();
                array_unshift($installedPartners, 'WordPress');

                /* translators: CSV of Application Names, i.e. "WordPress" */
	            printf(__('Connects to %s', 'fusedesk'), implode(', ', $installedPartners));
            ?>
        </p>


        <form method="post" accept-charset="UTF-8" action="https://asandia.infusionsoft.com/app/form/process/40b425a09c9d065e9004e2934b2bfbc4">
            <input name="inf_form_xid" type="hidden" value="40b425a09c9d065e9004e2934b2bfbc4">
            <input name="inf_form_name" type="hidden" value="WordPress Free App Opt-In">
            <input name="infusionsoft_version" type="hidden" value="1.70.0.426972">
            <input type="hidden" name="inf_field_Website" value="<?php echo(site_url()); ?>">
            <input type="hidden" name="inf_field_LeadSourceName" value="WordPress-Plugin-App-Form">
            <input type="hidden" name="inf_custom_GACampaign" value="WordPress Plugin">
            <input type="hidden" name="inf_custom_GASouce" value="WordPress Plugin App Form">
            <input type="hidden" name="utm_campaign" value="WordPress-Plugin">
            <input type="hidden" name="utm_source" value="WordPress-Plugin-App-Form">

            <input name="inf_field_Email" type="email" autocomplete="email" value="<?php echo(fusedesk_myemail()); ?>" placeholder="<?php _e('Business Email', 'fusedesk'); ?>" size="35" required>

            <input type="submit" value="<?php _e('Get My App', 'fusedesk'); ?>" class="button-primary"><br/>

            <label for="inf_option_FollowUpWithMeaboutaFuseDeskApp">
                <input id="inf_option_FollowUpWithMeaboutaFuseDeskApp" name="inf_option_FollowUpWithMeaboutaFuseDeskApp" type="checkbox" value="1806" checked required>
                <?php
                /* translators: URLs */
                printf(__('I agree to FuseDesk\'s <a href="%s" target="_blank">Terms of Use</a> and <a href="%s" target="_blank">Privacy Policy</a>.', 'fusedesk'), 'https://www.fusedesk.com/pricing/billing/', 'http://www.fusedesk.com/privacy/');
                ?>
            </label>

        </form>
    </div>

<?php } ?>

    <h2><?php _e('Third-Party Integrations', 'fusedesk'); ?></h2>

    <p><?php _e('FuseDesk plays very nicely with a number of great plugins. Simply install these for increased functionality.', 'fusedesk'); ?></p>

    <table>
        <thead>
        <tr>
            <td><?php _e('Plugin', 'fusedesk'); ?></td>
            <td><?php _e('Installed?', 'fusedesk'); ?></td>
            <td><?php _e('Functionality', 'fusedesk'); ?></td>
        </tr>
        </thead>
        <?php $teamsSupported = false; foreach(fusedesk_partners() as $partnername => $partner) { ?>
    <tr>
        <td><a href="<?php echo($partner['site']); ?>" target="_blank"><?php echo($partner['name']); ?></a></td>
        <td><?php echo(fusedesk_checkpartner($partnername) ? '<span style="color:green"><strong>Installed!</strong></span>' : 'Not Installed'); ?></td>
        <td>
            <?php
            if($partner['appname']) { _e('Pre-filled App Name. ', 'fusedesk'); }
            if($partner['contactid']) { _e('Instant new case link. ', 'fusedesk'); }
            if($partner['contact']) { _e('Pre-filled contact info. ', 'fusedesk'); }
            if($partner['teamcases']) { _e('Show team cases. ', 'fusedesk');
                if(fusedesk_checkpartner($partnername)) {
                    $teamsSupported = true;
                }
            }
            if($partner['forms']) { _e('Form submissions can create cases. ', 'fusedesk'); }
            ?>
            </td>
    </tr>
        <?php } ?>
    </table>

    <?php foreach(fusedesk_partners() as $partnername => $partner) {
        if(fusedesk_checkpartner($partnername) and $partner['knownissues']) { ?>
            <p><b><?php
		            /* translators: software vendor name */
                    printf(__('Known Issues for %s', 'fusedesk'), $partner['name']); ?></b><ol>
                    <?php foreach($partner['knownissues'] as $issue) { ?>
                        <li><?php echo($issue); ?></li>
    <?php } ?>
                    </ol>
    <?php }} ?>

<?php if($isApiKeyValid) { ?>
    <h2><?php _e('Getting Started', 'fusedesk'); ?></h2>

    <p><?php _e('Let customers open new cases! Add a <strong>FuseDesk New Case</strong> block (or <code>[fusedesk_newcase /]</code> shortcode) to your Contact Us page!', 'fusedesk'); ?></p>

    <p><?php _e('Let customers see their cases! Add a <strong>FuseDesk My Cases</strong> block (or <code>[fusedesk_mycases /]</code> shortcode) to a new page for logged in users only!', 'fusedesk'); ?></p>

    <p><?php _e('Let members see their team\'s cases! Add <strong>FuseDesk My Team Cases</strong> block (or <code>[fusedesk_teamcases /]</code> shortcode) to a new page for logged in users only!', 'fusedesk'); ?></p>

    <h2><?php _e('Advanced Shortcode Usage', 'fusedesk'); ?></h2>

    <p><?php _e('If you\'re using shortcodes instead of Blocks, you will be setting all of your options with the shortcode parameters below.', 'fusedesk'); ?></p>

    <h3><?php _e('New Case Form', 'fusedesk'); ?></h3>

    <p><?php _e('To allow folks to open a new support case, use the <code>[fusedesk_newcase]</code> shortcode on a page. This will display a form.', 'fusedesk'); ?></p>

    <p><?php _e('<code>[fusedesk_newcase]</code> works perfectly by itself, but also supports the following optional parameters:', 'fusedesk'); ?></p>

    <ul class="ul-disc">
        <li><code>department</code>: <?php _e('The ID of the department to assign the case to. Defaults to your default department above.', 'fusedesk'); ?></li>
        <li><code>rep</code>: <?php _e('The ID of the rep to assign the case to. Defaults to your default rep above.', 'fusedesk'); ?></li>
        <li><code>casetagids</code>: <?php _e('Comma separated list of FuseDesk Case Tag IDs that you want to apply to new cases. Defaults to not applying any case tags.', 'fusedesk'); ?></li>
        <li><code>hideknowndata</code>: <?php _e('Hide the name and/or email fields if we know who the user is (i.e. they\'re logged in.) Defaults to showing the fields pre-filled in', 'fusedesk'); ?></li>
        <li><code>nametext</code>: <?php _e('The label for the name field. Defaults to "Your Name"', 'fusedesk'); ?></li>
        <li><code>emailtext</code>: <?php _e('The label for the email field. Defaults to "Your Email Address"', 'fusedesk'); ?></li>
        <li><code>messagetext</code>: <?php _e('The label for the message box. Defaults to "How can we help you?"', 'fusedesk'); ?></li>
        <li><code>buttontext</code>: <?php _e('What to show on the button to create the case. Defaults to "Create Support Case"', 'fusedesk'); ?></li>
        <li><code>creatingtext</code>: <?php _e('What to show while a case is being submitted. Defaults to "Submitting Case..."', 'fusedesk'); ?></li>
        <li><code>successtext</code>: <?php _e('What to show after the case is created. Defaults to "Thanks! Your case has been created. We will get back to you shortly."', 'fusedesk'); ?></li>
        <li><code>successredirect</code>: <?php _e('URL (relative or absolute) to redirect to after a case is created. Default is not to redirect', 'fusedesk'); ?></li>
        <li><code>class</code>: <?php _e('What CSS class to apply to our inputs', 'fusedesk'); ?></li>
        <li><code>style</code>: <?php _e('What CSS style to apply to our inputs', 'fusedesk'); ?></li>
        <li><code>table</code>: <?php _e('Display the inputs in a table instead of breaking with newlines. Note that if you include any additional content (see below) and you turn table output on, you\'ll need to put your additional content in table rows and cells with <code>&lt;tr&gt;</code> and <code>&lt;td&gt;</code> tags', 'fusedesk');?></li>
        <li><code>showtitle</code>: <?php _e('Prompt for a case title. Defaults to false (i.e. don\'t ask for a case title)', 'fusedesk'); ?></li>
        <li><code>titleoptions</code>: <?php _e('Optional CSV options for a case title dropdown. If this attribute is set, title will also be shown.', 'fusedesk'); ?></li>
        <li><code>titletext</code>: <?php _e('The prompt for the case title/subject. Defaults to "Briefly, what is this request about?"', 'fusedesk'); ?></li>
        <li>File Upload Support:<ul class="ul-disc">
            <li><code>fileupload</code>: <?php _e('Prompt for optional file upload. Set to anything to allow file uploads. Note that files will be uploaded and stored on your WordPress install and a link to the files will be included in the FuseDesk case. You should likely not enable this on public facing forms and you should be mindful of asking for any sensitive data. Defaults to not allowed.', 'fusedesk'); ?></li>
            <li><code>filetext</code>: <?php _e('What text to show next to the file upload control. Defaults to "Attach a File"', 'fusedesk'); ?></li>
            <li><code>filerequired</code>: <?php _e('If file uploads are allowed, if they should be required. Set to anything to require a file. Defaults to not required.', 'fusedesk'); ?></li>
            <li><code>filesmultiple</code>: <?php _e('If file uploads are allowed, allow multiple files to be uploaded. Set to <code>0</code> to disable. Defaults to allowed.', 'fusedesk'); ?></li>
            <li><code>filetypesallowed</code>: <?php
	            /* translators: URL, file types list */
                printf(__('If file uploads are allowed, comma separated list of what <a href="%1$s" target="_blank">file types</a> are supported. These can be file extensions, partial MIME types, and more. Defaults to <code>%2$s</code>', 'fusedesk'), 'https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input/file#Unique_file_type_specifiers', 'image/*,audio/*,application/pdf');
                ?></li>
        </ul></li>
        <li><?php _e('Suggested Posts', 'fusedesk'); ?><ul class="ul-disc">
            <li><code>suggestionstext</code>: <?php _e('The label for suggested posts. Defaults to "May we suggest one of the following posts?"', 'fusedesk'); ?></li>
            <li><code>suggestionlimit</code>: <?php _e('How many posts to suggest. Defaults to 10.', 'fusedesk'); ?></li>
            <li><code>suggestioncategories</code>: <?php _e('Comma separated list of category names/slugs you want to restrict suggestions to. Defaults to all categories.', 'fusedesk'); ?></li>
            <li><code>suggestionplacement</code>: <?php _e('Where to place the suggested posts. Can be set to <code>before</code> (default), <code>after</code>, <code>end</code>, or <code>none</code> (to disable)', 'fusedesk');?></li>
            </ul></li>
    </ul>

    <p><?php _e('Again, all of these parameters are optional but they allow you to override any of the defaults.', 'fusedesk'); ?></p>

    <p><?php _e('An example to not show the name or email if present, changing the new case button text and change the name text:', 'fusedesk');?><br/>
        <code>[fusedesk_newcase hideknowndata="true" nametext="<?php _e('Primary Contact', 'fusedesk'); ?>" buttontext="<?php _e('Get Help!', 'fusedesk'); ?>" /]</code>
    </p>

    <p><?php _e('Whatever content you put between <code>[fusedesk_newcase]</code> and <code>[/fusedesk_newcase]</code> tags will be added into the case details.', 'fusedesk');?></p>

    <p>
        <?php _e('For example, if you wanted to include some hidden data about the customer, you could put a hidden input inside, like:', 'fusedesk');?><br/>
        <code>[fusedesk_newcase]&lt;input type="hidden" name="website" value="http://members.mysite.com/"&gt;[/fusedesk_newcase]</code>
    </p>

    <p>
        <?php _e('You could also add some additional options and fields, for example: ', 'fusedesk'); ?><br/>
        <code>[fusedesk_newcase]<?php _e('Order #:'); ?> &lt;input type="text" name="order_number"&gt;[/fusedesk_newcase]</code>
    </p>

    <p>
        <?php _e('You could even go all out and add in a drop down, like:', 'fusedesk');?><br/>
        <code>[fusedesk_newcase]&lt;select name="cruise_type"&gt;
        &lt;option value="Bahamas"&gt;Bahamas&lt;/option&gt;<br/>
        &lt;option value="Alaska"&gt;Alaska&lt;/option&gt;<br/>
        &lt;option value="Mediterranean"&gt;Mediterranean&lt;/option&gt;<br/>
        &lt;/select&gt;[/fusedesk_newcase]</code>
    </p>

    <p><?php _e('If you name your additional fields with underscores, like cruise_type, operating_system, favorite_place_to_hike, etc..., we\'ll automatically translate those to title case, i.e. "Cruise Type", and include them all in the case details.', 'fusedesk'); ?></p>

    <p><?php _e('You can include an input with <code>name="summary"</code> in your content to handle the case title/summary in your own custom way and we won\'t include the default case title.', 'fusedesk'); ?></p>

    <p><?php _e('<b>Note:</b> The examples above are using HTML input fields. These need to be added by editing your page in HTML mode.', 'fusedesk'); ?></p>

    <p><?php _e('<b>Second Note:</b> If you include any additional content above and you turn table output on, you\'ll need to put your additional content in table rows and cells with <code>&lt;tr&gt;</code> and <code>&lt;td&gt;</code> tags', 'fusedesk');?></p>

    <p><?php _e('To <b>style your form</b> and form elements, either pass in the <code>style</code> parameter or <code>class</code> parameter or add entries for each of our elements into your style sheet. Pre-set IDs and classes include:', 'fusedesk'); ?></p>

    <ul class="ul-disc">
        <li>.fusedesk-contactform: <?php _e('all form elements have this class', 'fusedesk'); ?></li>
        <li>#fusedesk-contact: <?php _e('the actual form', 'fusedesk'); ?></li>
        <li>#fusedesk-contact-table: <?php _e('the form table, if enabled', 'fusedesk'); ?></li>
        <li>#fusedesk-contact-email: <?php _e('the email address input field', 'fusedesk'); ?></li>
        <li>#fusedesk-contact-name: <?php _e('the name input field', 'fusedesk'); ?></li>
        <li>#fusedesk-title: <?php _e('the title input field', 'fusedesk'); ?></li>
        <li>#fusedesk-message: <?php _e('the textarea for the case details', 'fusedesk'); ?></li>
        <li>#fusedesk-contactform-submit: <?php _e('the submit button', 'fusedesk'); ?></li>
        <li>#fusedesk-suggestions: <?php _e('the div that holds the suggestions list', 'fusedesk'); ?></li>
    </ul>

    <h3><?php _e('Displaying a Customer\'s Cases', 'fusedesk'); ?></h3>

    <p><?php _e('To display a list of cases for the logged in user, use the <code>[fusedesk_mycases]</code> shortcode on a page. This will display a table listing all of their cases.', 'fusedesk'); ?></p>

    <p><?php _e('<code>[fusedesk_mycases]</code> works wonders by itself, but also supports the following optional parameters:', 'fusedesk'); ?></p>

    <ul class="ul-disc">
        <li><code>columns</code>: <?php _e('A comma delimited list of which columns to show. Choose from <code>casenum</code>, <code>date_updated</code>, <code>date_opened</code>, <code>date_closed</code>, <code>status</code>, <code>summary</code>, <code>details</code>. Defaults to "<code>casenum,date_updated,status,summary</code>"', 'fusedesk'); ?></li>
        <li><code>status</code>: <?php _e('Filter for which case statuses to show. Options are <code>new</code>, <code>active</code>, <code>open</code>, and <code>closed</code>. If blank, defaults to All Cases.', 'fusedesk'); ?></li>
        <li><code>userstatuses</code>: <?php _e('Filter for which case statuses you allow a user to set with the <code>casestatus</code> query parameter. Expects a CSV with none to any of <code>new</code>, <code>active</code>, <code>open</code>, and <code>closed</code>. If not set, defaults to any valid status. Setting this restriction allows you to prevent users from viewing certain cases statuses like closed cases, for example.', 'fusedesk'); ?></li>
        <li><code>limit</code>: <?php _e('How many cases (max) to display. Defaults to <code>50</code>', 'fusedesk'); ?></li>
        <li><code>orderby</code>: <?php _e('How to sort your cases. Expects a CSV of date and order pairs, i.e. <code>date_lastresponse desc</code>, or <code>date_opened asc</code> Defaults to <code>date_lastresponse asc, date_updated asc</code>', 'fusedesk'); ?></li>
        <li><code>dateformat</code>: <?php _e('How to format your dates. Accepts PHP\'s <a href="http://php.net/manual/en/function.date.php" target="_blank">date</a> formatting. Defaults to <code>M j, Y g:ia</code>', 'fusedesk'); ?></li>
        <li><code>errornotloggedin</code>: <?php _e('What message to show to customers who aren\'t logged in (since we won\'t be able to show cases to anyone who\'s not logged in. Defaults to "<code>Please login to view your cases.</code>" It is highly recommended that you add only put this code on pages visible to logged in users only.', 'fusedesk'); ?></li>
        <li><code>errornocases</code>: <?php _e('What message to show to customers where they don\'t have any cases. Defaults to "<code>Looks like you don\'t have any support cases!</code>"', 'fusedesk'); ?></li>
        <li>{columnName}_name: <?php _e('What to title a given column (see <code>columns</code> above). For example, to change the column name for <code>casenum</code> to <code>Request #</code>, use <code>casenum_name="Request #"</code>.', 'fusedesk'); ?></li>
    </ul>

    <p>
        <?php _e('For example, to use many of the above options, try:', 'fusedesk'); ?>
        <code>
            [fusedesk_mycases columns="casenum, status, date_opened" status="active" limit="10" orderby="date_lastresponse desc, date_opened asc" dateformat="M d" errornocases="<?php _e('Hooray, you don\'t have any active requests!', 'fusedesk'); ?>" casenum_name="<?php _e('Request #', 'fusedesk') ?>" date_opened_name="<?php _e('Start Date', 'fusedesk') ?>" /]
        </code>
    </p>

    <h4><?php _e('Filtering with Query Params', 'fusedesk'); ?></h4>
    <p>
        <?php _e('You can allow members to filter cases using a query param of <code>casestatus</code>. For example, link to your My Cases page with <code>casestatus=new</code> in the query string to filter just for new cases. The case status must be one of the allowed statuses from <code>userstatuses</code> above.', 'fusedesk'); ?>
    </p>
    <p>
        <?php _e('You can allow members to filter cases by dates, too. We\'ll check for any of the following in the query string and expect a valid <a href="https://www.php.net/manual/en/function.strtotime.php" target="_blank">parsable PHP date</a>, which includes relative dates like "-30 days"'); ?>':
        <code>date_opened_before</code>,
        <code>date_opened_after</code>,
        <code>date_closed_before</code>,
        <code>date_closed_after</code>,
        <code>date_updated_before</code>.
        <code>date_updated_after</code>.
    </p>

    <p><?php _e('For example, to search for cases opened in the last 30 days, put <code>date_opened_after=-30 days</code> in your query string.', 'fusedesk'); ?></p>

    <h3><?php _e('Displaying a Team\'s Cases', 'fusedesk'); ?></h3>

    <p><?php _e('Some CRMs and Membership Sites support parent / child logins or linked users / teams.', 'fusedesk'); ?></p>

    <?php if(!$teamsSupported) { ?>
        <p><b><?php _e('Important: You do NOT have a Membership Site that supports Team Cases!', 'fusedesk'); ?></b></p>
    <?php } ?>

    <p><?php _e('To display a list of cases for the logged in user\'s team, use the <code>[fusedesk_teamcases]</code> shortcode on a page. All of the options are the same as for <code>[fusedesk_mycases]</code> above with two additional error codes.', 'fusedesk'); ?></p>

    <ul class="ul-disc">
        <li><code>errornotsupported</code>: <?php _e('What message to show users when your membership site platform doesn\'t support teams.', 'fusedesk'); ?></li>
        <li><code>errornoteam</code>: <?php _e('What message to show users who aren\'t part of a team.', 'fusedesk'); ?></li>
    </ul>

<?php } ?>

<?php if(fusedesk_checkpartner('gravityforms')) { ?>

    <h3><?php _e('Gravity Forms', 'fusedesk'); ?></h3>

    <p><?php _e('FuseDesk works beautifully with <a href="?page=gf_edit_forms">Gravity Forms</a> to create a new FuseDesk case when a form is submitted.', 'fusedesk'); ?></p>

    <p><?php _e('To enable this, simply click the FuseDesk option under settings for your form and check the box to create a case. Then, choose your department, optional rep, and optional case title.', 'fusedesk'); ?></p>

    <p><?php _e('If you want to get really advanced with your case creation, you can set a form field\'s <a href="https://www.gravityforms.com/gravity-forms-feature-highlight-admin-labels/" target="_blank">Admin Label</a> to one of the following and FuseDesk will use the value of that field when creating the case:', 'fusedesk'); ?></p>

    <ul class="ul-disc">
        <li><code>openedby</code>:<?php _e(' The name of the person creating the case (use this for your "name" form field)', 'fusedesk'); ?></li>
        <li><code>summary</code>:<?php _e(' The summary/title for your FuseDesk Case', 'fusedesk'); ?></li>
        <li><code>depid</code>:<?php _e(' The FuseDesk department ID to assign the case to', 'fusedesk'); ?></li>
        <li><code>repid</code>:<?php _e(' The FuseDesk rep User ID to assign the case to', 'fusedesk'); ?></li>
        <li><code>email</code>:<?php _e(' The email address to link the case to', 'fusedesk'); ?></li>
        <li><code>casetags</code>:<?php _e(' A CSV of case tag IDs or names to assign to the case', 'fusedesk'); ?></li>
    </ul>

<?php } ?>

    <a name="apikey"></a><h2><?php _e('Finding your FuseDesk API Key', 'fusedesk'); ?></h2>

    <?php if(!get_option('fusedesk_apikey')) { ?>
    <p><?php _e('Getting your FuseDesk API Key couldn\'t be easier! Simply enter your App Name above, then click on the <b>Get API Key</b> button and follow the instructions.', 'fusedesk'); ?></p>
    <?php } else { ?>
    <p>
        <?php _e('To setup a FuseDesk API Key, you\'ll need to:', 'fusedesk'); ?></p>
    <ol>
        <li><?php
            if(get_option('fusedesk_appname')) {
                /* translators: URL */
                printf(__('<a href="%s" target="_blank">Log into your FuseDesk App</a> as an admin', 'fusedesk'), 'https://'.get_option('fusedesk_appname').'fusedesk.com/app/#apikeys');
            } else {
                /* translators: URL */
                printf(__('<a href="%s" target="_blank">Log into your FuseDesk App</a> as an admin', 'fusedesk'), 'https://www.fusedesk.com/login/');
            } ?></li>
        <li><?php _e('Click on Settings', 'fusedesk'); ?></li>
        <li><?php _e('Click on API Keys', 'fusedesk'); ?></li>
        <li><?php _e('Use an existing API Key or create a new one', 'fusedesk'); ?></li>
        <li><?php _e('Copy the Key to your clipboard and paste it above.', 'fusedesk'); ?></li>
    </ol>
    <?php } ?>

</div>


<script type="text/javascript">
    jQuery(function() {
        jQuery('#fusedesk_testbutton').click(function() {

            if(!jQuery('#fusedesk_appname').val())
            {
                alert("<?php _e('Please enter your FuseDesk application name.', 'fusedesk'); ?>");
                jQuery('#fusedesk_appname').focus();
                return false;
            } else if (!jQuery('#fusedesk_apikey').val()) {
                alert("<?php _e('Please enter your FuseDesk API Key', 'fusedesk'); ?>");
                return false;
            }

            jQuery.get("https://" + jQuery('#fusedesk_appname').val() + ".fusedesk.com/api/v1/session/permissions", {apikey: jQuery('#fusedesk_apikey').val()}, function(response) {
                if(response.error)
                {
                    alert("<?php _e('Uh oh, looks like that FuseDesk API Key isn\'t valid: ', 'fusedesk'); ?>" + response.error);
                } else {
                    // Let's make sure we have our required scopes
                    var requiredScopes = ['reps','departments','cases','cases_create','cases_update','integrations'];
                    for (var i = 0; i < requiredScopes.length; i++) {
                        var requiredScope = requiredScopes[i];
                        if(response.indexOf(requiredScope) < 0)
                        {
                            alert("<?php _e('Your FuseDesk API Key and App name are valid, BUT your FuseDesk API key doesn\'t have all of the required permissions. Missing: ', 'fusedesk'); ?>\"" + requiredScope + "\"");
                            return;
                        }
                    }

                    alert("<?php _e('FuseDesk API Key and App name are good! Click \'Save Changes\' to save your changes!', 'fusedesk'); ?>");
                }
            }).fail(function(response, textStatus, errorThrown) {
                alert("<?php _e('Uh oh. Looks like that FuseDesk API Key isn\'t valid...', 'fusedesk'); ?>");
            });
        });

        jQuery('#fusedesk_appname').blur(function() {
            jQuery('#fusedesk_appname').val(
                jQuery('#fusedesk_appname').val().
                replace(/^.*\/\//,'').
                replace(/\.(fusedesk|infusionsoft).*/ ,''));
            return true;
        });

        jQuery('#fusedesk_getkey').click(function() {
            if(jQuery('#fusedesk_appname').val()) {
                window.location = "https://" + jQuery('#fusedesk_appname').val() + ".fusedesk.com/app/#apikeys?newkey=<?php
                echo(urlencode(get_bloginfo('name'))); ?>&scopes=reps|departments|cases|cases_create|cases_update|integrations&returnurl=<?php
                echo(urlencode(get_bloginfo('wpurl').'/wp-admin/options-general.php?page=fusedesk')); ?>";
            } else {
                alert("<?php _e('Please enter your application name.', 'fusedesk'); ?>");
                jQuery('#fusedesk_appname').focus();
                return false;
            }
        });

        jQuery('#fusedesk_reps_refresh').click(function() {
            jQuery('#fusedesk_reps_refresh').attr('disabled', 'disabled');
            // the_ajax_script.ajaxurl is a variable that will contain the url to the ajax processing file
            jQuery.get({
                url: the_ajax_script.ajaxurl,
                data: {action: 'fusedesk_reps', refresh: true},
                dataType: 'json'
            }).done(function(reps) {
                var repSelect = jQuery('#fusedesk_defaultrep');
                var existingDefaultRep = repSelect.val();

                if(reps) {
                    // Remove all of our options
                    jQuery("#fusedesk_defaultrep option").remove();

                    repSelect.append(new Option('Assign Randomly', '', existingDefaultRep === ''));

                    // Re-add all of our options
                    Object.keys(reps).forEach(function(repUserId) {
                        var repName = reps[repUserId];
                        repSelect.append(new Option(repName + ' (' + repUserId + ')', repUserId, false, existingDefaultRep == repUserId));
                    });
                }
                jQuery('#fusedesk_reps_refresh').removeAttr('disabled');
            });
        });

        jQuery('#fusedesk_departments_refresh').click(function() {
            jQuery('#fusedesk_departments_refresh').attr('disabled', 'disabled');
            // the_ajax_script.ajaxurl is a variable that will contain the url to the ajax processing file
            jQuery.get({
                url: the_ajax_script.ajaxurl,
                data: {action: 'fusedesk_departments', refresh: true},
                dataType: 'json'
            }).done(function(departments) {
                var departmentSelect = jQuery('#fusedesk_defaultdepartment');
                var existingDefaultdepartment = departmentSelect.val();

                if(departments) {
                    // Remove all of our options
                    jQuery("#fusedesk_defaultdepartment option").remove();

                    departmentSelect.append(new Option('Assign Randomly', '', existingDefaultdepartment === ''));

                    // Re-add all of our options
                    Object.keys(departments).forEach(function(departmentId) {
                        var departmentName = departments[departmentId];
                        departmentSelect.append(new Option(departmentName + ' (' + departmentId + ')', departmentId, false, existingDefaultdepartment == departmentId));
                    });
                }
                jQuery('#fusedesk_departments_refresh').removeAttr('disabled');
            });
        });

        jQuery('#fusedesk_chatwidgets_refresh').click(function() {
            jQuery('#fusedesk_chatwidgets_refresh').attr('disabled', 'disabled');
            // the_ajax_script.ajaxurl is a variable that will contain the url to the ajax processing file
            jQuery.get({
                url: the_ajax_script.ajaxurl,
                data: {action: 'fusedesk_chatwidgets', refresh: true},
                dataType: 'json'
            }).done(function(chatWidgets) {
                var chatWidgetSelect = jQuery('#fusedesk_defaultchatwidget');
                var existingDefaultChatWidget = chatWidgetSelect.val();

                if(chatWidgets) {
                    // Remove all of our options
                    jQuery("#fusedesk_defaultchatwidget option").remove();

                    chatWidgetSelect.append(new Option('[Live Chat Disabled]', '', existingDefaultChatWidget === ''));

                    // Re-add all of our options
                    Object.keys(chatWidgets).forEach(function(chatWidgetId) {
                        var chatWidgetName = chatWidgets[chatWidgetId];
                        chatWidgetSelect.append(new Option(chatWidgetName, chatWidgetId, false, existingDefaultChatWidget == chatWidgetId));
                    });
                }
                jQuery('#fusedesk_chatwidgets_refresh').removeAttr('disabled');
            });
        });

    });


</script>